﻿Imports System.Management
Imports System.IO
Imports Microsoft.Win32
Imports System.Security.Principal
Imports System.Threading
Imports System.DirectoryServices

Public Class Info

    Private pSystemDirectory As String
    Private pName As String
    Private pOU As String
    Private pModel As String
    Private pSerial As String
    Private pBIOS As String
    Private pComment As String
    Private pIP As String
    Private pDHCP As Boolean
    Private pOS As String
    Private pCPU As String
    Private pCPU_Speed As Integer
    Private pMemory As Integer
    Private pDisk_Size As Integer
    Private pDisk_Free As Integer
    Private pInstallRev As String
    Private pInstallDate As Date
    Private pOffice As String
    Private pIE As String
    Private pVirus_Scan As Date
    Private pVirus_Defs As Date
    Private pVirus_Ver As String
    Private pLastQFE As Date
    Private pLastBoot As Date

    Public Sub New()
        pSystemDirectory = "C:\Windows"
        pName = ""
        pOU = ""
        pModel = ""
        pSerial = ""
        pBIOS = ""
        pComment = ""
        pIP = ""
        pDHCP = False
        pOS = ""
        pCPU = ""
        pCPU_Speed = 0
        pMemory = 0
        pDisk_Size = 0
        pDisk_Free = 0
        pInstallRev = ""
        pInstallDate = Date.MinValue
        pOffice = ""
        pIE = ""
        pVirus_Scan = Date.MinValue
        pVirus_Defs = Date.MinValue
        pVirus_Ver = ""
        pLastQFE = Date.MinValue
        pLastBoot = Date.MinValue
    End Sub

    Public ReadOnly Property SystemDirectory() As String
        Get
            Return pSystemDirectory
        End Get
    End Property

    Public ReadOnly Property Name() As String
        Get
            Return pName
        End Get
    End Property

    Public ReadOnly Property OU() As String
        Get
            Return pOU
        End Get
    End Property

    Public ReadOnly Property Model() As String
        Get
            Return pModel
        End Get
    End Property

    Public ReadOnly Property Serial() As String
        Get
            Return pSerial
        End Get
    End Property

    Public ReadOnly Property BIOS() As String
        Get
            Return pBIOS
        End Get
    End Property

    Public ReadOnly Property Comment() As String
        Get
            Return pComment
        End Get
    End Property

    Public ReadOnly Property IP() As String
        Get
            Return pIP
        End Get
    End Property

    Public ReadOnly Property DHCP() As Boolean
        Get
            Return pDHCP
        End Get
    End Property

    Public ReadOnly Property OS() As String
        Get
            Return pOS
        End Get
    End Property

    Public ReadOnly Property CPU() As String
        Get
            Return pCPU
        End Get
    End Property

    Public ReadOnly Property CPU_Speed() As Integer
        Get
            Return pCPU_Speed
        End Get
    End Property

    Public ReadOnly Property Memory() As Integer
        Get
            Return pMemory
        End Get
    End Property

    Public ReadOnly Property Disk_Size() As Integer
        Get
            Return pDisk_Size
        End Get
    End Property

    Public ReadOnly Property Disk_Free() As Integer
        Get
            Return pDisk_Free
        End Get
    End Property

    Public ReadOnly Property InstallRev() As String
        Get
            Return pInstallRev
        End Get
    End Property

    Public ReadOnly Property InstallDate() As Date
        Get
            Return pInstallDate
        End Get
    End Property

    Public ReadOnly Property Office() As String
        Get
            Return pOffice
        End Get
    End Property

    Public ReadOnly Property IE() As String
        Get
            Return pIE
        End Get
    End Property

    Public ReadOnly Property Virus_Scan() As Date
        Get
            Return pVirus_Scan
        End Get
    End Property

    Public ReadOnly Property Virus_Defs() As Date
        Get
            Return pVirus_Defs
        End Get
    End Property

    Public ReadOnly Property Virus_Ver() As String
        Get
            Return pVirus_Ver
        End Get
    End Property

    Public ReadOnly Property LastQFE() As Date
        Get
            Return pLastQFE
        End Get
    End Property

    Public ReadOnly Property LastBoot() As Date
        Get
            Return pLastBoot
        End Get
    End Property

    Public Sub Doit(ByVal RemotePC As String)
        Dim MgmtPath, SystemDrive, ResourceDomain, VerFile, Word_Path As String
        Dim num As Integer
        Dim wmi As ManagementClass
        Dim obj As ManagementObject
        Dim reg_hklm, reg_hkcr, key As RegistryKey

        MgmtPath = ""
        If RemotePC <> "" Then
            MgmtPath = "\\" & RemotePC & "\root\cimv2:"
        End If

        ' open the registry keys (local or remote)
        If RemotePC <> "" Then
            reg_hkcr = RegistryKey.OpenRemoteBaseKey(RegistryHive.ClassesRoot, RemotePC)
            reg_hklm = RegistryKey.OpenRemoteBaseKey(RegistryHive.LocalMachine, RemotePC)
        Else
            reg_hkcr = Registry.ClassesRoot
            reg_hklm = Registry.LocalMachine
        End If

        ' save this as the "root" of the other WMI calls
        ResourceDomain = ""
        wmi = New ManagementClass(MgmtPath & "Win32_ComputerSystem")
        For Each obj In wmi.GetInstances()
            Dim manufacturer, model As String

            ' The Name could be different from RemotePC (ie,
            ' RemotePC could be an IP address)
            pName = obj("Name").ToString
            ResourceDomain = obj("Domain").ToString

            manufacturer = obj("Manufacturer").ToString
            model = obj("Model").ToString
            If manufacturer.StartsWith("System") Then
                pModel = model
            Else
                pModel = manufacturer.Split(" "c)(0) & " " & model
            End If
        Next

        ' Get the OS version
        SystemDrive = "C:"
        wmi.Path.RelativePath = "Win32_OperatingSystem"
        For Each obj In wmi.GetInstances()
            Dim cnt As Integer
            Dim temp, csd, parts() As String
            Dim OSVer As Double

            ' just one decimal point please
            parts = Split(obj("Version").ToString, ".")
            If parts.GetUpperBound(0) >= 1 Then
                OSVer = CDbl(parts(0) & "." & parts(1))
            End If

            pSystemDirectory = obj("WindowsDirectory").ToString
            SystemDrive = Left(pSystemDirectory, 2)
            pComment = obj("Description").ToString

            ' "Name" is the best OS Name... but it has a bizzare format so
            ' we have to parse it
            cnt = InStr(obj("Name").ToString, "|")
            If cnt > 0 Then
                temp = Left(obj("Name").ToString, cnt - 1)
            Else
                temp = obj("Caption").ToString
            End If
            csd = ""
            If Not IsNothing(obj("csdversion")) Then
                csd = obj("csdversion").ToString
            End If

            ' shorten it up a bit for the SOS summary table
            If temp.StartsWith("Microsoft Windows NT") Then
                pOS = Replace(temp, "Microsoft ", "") & " " & Format(OSVer, "0.0") & " " & Trim(Replace(obj("csdversion").ToString, "Service Pack", "SP"))
            Else
                pOS = Replace(temp, "Microsoft ", "") & " " & Trim(Replace(csd, "Service Pack", "SP"))
            End If

            If Not IsNothing(obj("LastBootUpTime")) Then
                pLastBoot = ManagementDateTimeConverter.ToDateTime(obj("LastBootUpTime").ToString)
            End If
        Next

        ' Get the BIOS rev level
        wmi.Path.RelativePath = "Win32_BIOS"
        For Each obj In wmi.GetInstances()
            ' we prefer the SMB BIOS version, if available
            If CBool(obj("SMBIOSPresent")) Then
                pBIOS = obj("SMBIOSBIOSVersion").ToString
            Else
                pBIOS = obj("Version").ToString
            End If
        Next

        ' Get CPU type and Speed
        wmi.Path.RelativePath = "Win32_Processor"
        For Each obj In wmi.GetInstances()
            Dim RawSpeed, ExtSpeed As Integer

            ' we prefer Name, but Caption will do in a pinch
            If IsNothing(obj("Name")) Then
                pCPU = obj("Caption").ToString.Trim
            Else
                pCPU = obj("Name").ToString.Trim
            End If

            ' The value for CPU_Name is often too complex to sort on, so
            ' we generate a simpler name here
            If Not IsNothing(obj("Manufacturer")) And Not IsNothing(obj("ProcessorID")) AndAlso obj("ProcessorID").ToString.Length = 16 Then
                pCPU = GetCPUType(obj("Manufacturer").ToString, obj("ProcessorID").ToString)
            End If

            ' shorten it up a wee bit
            If Not pCPU.IndexOf("Family") >= 0 Then
                pCPU = Replace(pCPU, "Intel ", "")
            End If
            pCPU = Replace(pCPU, " processor", "")

            RawSpeed = Convert.ToInt32(obj("CurrentClockSpeed"))
            ' for PC's on battery power
            If Not IsNothing(obj("MaxClockSpeed")) Then
                RawSpeed = Convert.ToInt32(obj("MaxClockSpeed"))
            End If
            ExtSpeed = 0
            If Not IsNothing(obj("ExtClock")) Then
                ExtSpeed = Convert.ToInt32(obj("ExtClock"))
            End If
            pCPU_Speed = RoundCPUSpeed(RawSpeed, ExtSpeed)
        Next

        ' Get the amount of installed RAM
        wmi.Path.RelativePath = "Win32_PhysicalMemory"
        num = 0
        For Each obj In wmi.GetInstances()
            num = num + CInt(Convert.ToInt64(obj("capacity")) / (1024 * 1024))
        Next
        ' round off to a multiple of 2
        pMemory = CInt(IIf((num Mod 2) <> 0, num + 1, num))

        ' Get the free disk space
        wmi.Path.RelativePath = "Win32_LogicalDisk"
        For Each obj In wmi.GetInstances()
            ' skip network drives
            If Convert.ToInt32(obj("drivetype")) <> 4 Then
                Dim temp As Integer
                If Not IsNothing(obj("FreeSpace")) Then
                    temp = CInt(Convert.ToDouble(obj("FreeSpace")) / (1024.0# * 1024.0#))
                Else
                    temp = 0
                End If
                pDisk_Free += temp
                If Not IsNothing(obj("Size")) AndAlso obj("size").ToString.Length < 20 Then
                    temp = CInt(Convert.ToDouble(obj("Size")) / (1024.0# * 1024.0#))
                Else
                    temp = 0
                End If
                pDisk_Size += temp
            End If
        Next

        ' Get the Install Version 
        VerFile = My.Settings.VersionFile
        If VerFile <> "" Then
            ' in case you didn't read the documentation :)
            If VerFile.StartsWith("\") Then
                VerFile = SystemDrive & VerFile
            End If

            VerFile = ConvUNC(RemotePC, VerFile)
            If File.Exists(VerFile) Then
                Dim temp As String
                Dim sr As IO.StreamReader
                sr = [File].OpenText(VerFile)
                Do While sr.Peek() > -1
                    temp = sr.ReadLine
                    ' if there are multiple entries, just keep the last one
                    If temp <> "" And Not temp.StartsWith(" ") And Not temp.StartsWith(ControlChars.Tab) Then
                        If temp.StartsWith("V") Then
                            temp = "v" & temp.Substring(1)
                        End If
                        pInstallRev = Replace(temp, ControlChars.Tab, " - ")
                    End If
                Loop
                sr.Close()
            End If
        End If

        ' Get the date the PC was first joined to the domain 
        If File.Exists(ConvUNC(RemotePC, pSystemDirectory & "\system32\config\netlogon.ftl")) Then
            pInstallDate = File.GetCreationTime(ConvUNC(RemotePC, pSystemDirectory & "\system32\config\netlogon.ftl"))
        End If

        ' Get the Serial Number
        wmi.Path.RelativePath = "Win32_ComputerSystemProduct"
        For Each obj In wmi.GetInstances()
            pSerial = obj("IdentifyingNumber").ToString
        Next
        ' Use the Chassis serial number if this SerialNumber is empty or blank
        If pSerial = "" Or pSerial.StartsWith("System") Then
            wmi.Path.RelativePath = "Win32_SystemEnclosure"
            For Each obj In wmi.GetInstances()
                pSerial = obj("SerialNumber").ToString
            Next
        End If
        ' if that doesn't work, use the motherboard's serial number
        If pSerial = "" Or pSerial.StartsWith("Chassis") Then
            wmi.Path.RelativePath = "Win32_BaseBoard"
            For Each obj In wmi.GetInstances()
                pSerial = obj("SerialNumber").ToString
            Next
        End If

        ' Get the IP Adress
        wmi.Path.RelativePath = "Win32_NetworkAdapterConfiguration"
        For Each obj In wmi.GetInstances()
            If Not IsNothing(obj("IPAddress")) AndAlso UBound(CType(obj("IPAddress"), String())) >= 0 And CBool(obj("IPEnabled")) Then
                Dim temp As String
                temp = Format_IP(CType(obj("IPAddress"), String())(0))
                If Not temp.StartsWith("000") Then
                    pIP = temp
                    If Not IsNothing(obj("DHCPEnabled")) Then
                        pDHCP = CBool(obj("DHCPEnabled"))
                    End If
                End If
            End If
        Next

        ' Microsoft Office Version (actually just Word... but that's close enough)
        Word_Path = ""
        key = reg_hkcr.OpenSubKey("CLSID\{00020900-0000-0000-C000-000000000046}\DefaultIcon", False)
        If Not IsNothing(key) Then
            Dim temp As String

            temp = key.GetValue("", "").ToString.Split(","c)(0)
            Word_Path = ConvUNC(RemotePC, temp)
            If File.Exists(Word_Path) Then
                pOffice = GetVersion(Word_Path)
            End If
            key.Close()
        End If
        ' Microsoft Office versions are complex... it's a combination of the
        ' application version numer and the office suite  version number.
        ' We get the suite number from the MSO.DLL or WWLIB.DLL file
        If pOffice <> "" And Word_Path.Length > 2 Then
            Dim Word_Version(), MSO_Path, MSO_Temp, MSO_Version() As String

            Word_Version = pOffice.Split("."c)
            If UBound(Word_Version) >= 2 Then

                Select Case CInt(Word_Version(0))
                    Case Is >= 12
                        ' for Office 2007 (and above?)
                        MSO_Path = Word_Path.ToLower.Replace("winword.exe", "wwlib.dll")
                        MSO_Temp = GetVersion(MSO_Path)
                        If MSO_Temp <> "" Then
                            MSO_Version = MSO_Temp.Split("."c)
                            If UBound(MSO_Version) >= 3 Then
                                pOffice = Word_Version(0) & "." & Word_Version(1) & "." & MSO_Version(2) & "." & MSO_Version(3)
                            End If
                        End If
                    Case 10, 11
                        ' for Office XP and Office 2003
                        MSO_Path = ""
                        key = reg_hkcr.OpenSubKey("odcnewfile\DefaultIcon", False)
                        If Not IsNothing(key) Then
                            Dim temp As String

                            temp = key.GetValue("", "").ToString.ToString.Split(","c)(0)
                            MSO_Path = ConvUNC(RemotePC, temp)
                            key.Close()
                        End If

                        If MSO_Path <> "" AndAlso File.Exists(MSO_Path) Then
                            MSO_Temp = GetVersion(MSO_Path)
                            If MSO_Temp <> "" Then
                                MSO_Version = MSO_Temp.Split("."c)
                                If UBound(MSO_Version) >= 2 Then
                                    pOffice = Word_Version(0) & "." & Word_Version(2) & "." & MSO_Version(2)
                                End If
                            End If
                        End If
                    Case Is < 10
                        ' for Office 2k and below
                        MSO_Path = Word_Path.ToLower.Replace("winword.exe", "mso") & Word_Version(0) & ".dll"
                        MSO_Temp = GetVersion(MSO_Path)
                        If MSO_Temp <> "" Then
                            pOffice = MSO_Temp
                        End If
                End Select
            End If
        End If


        key = reg_hklm.OpenSubKey("SOFTWARE\Microsoft\Windows\CurrentVersion\Group Policy\State\Machine", False)
        If Not IsNothing(key) AndAlso Not IsNothing(key.GetValue("Distinguished-Name")) Then
            Dim temp, parts() As String

            parts = key.GetValue("Distinguished-Name").ToString.Split(","c)
            If parts.Length > 3 Then
                temp = parts(1) & ", " & parts(2) & ", " & parts(3)
                pOU = temp.Replace("OU=", "")
            End If
            key.Close()
        End If
        If pOU = "" Then
            ' OK... we have to do it the hard way.  We do an LDAP
            ' search for this PC's distinguished name
            Dim root As DirectoryEntry
            Dim ad As DirectorySearcher
            Dim res As SearchResult

            Try
                root = New DirectoryEntry("LDAP://" & ResourceDomain)
                ad = New DirectorySearcher(root, "(&(objectclass=computer)(cn=" & pName & "))")
                res = ad.FindOne()
                If Not IsNothing(res) Then
                    Dim temp, parts() As String

                    parts = res.Properties("distinguishedName")(0).ToString.Split(","c)
                    If parts.Length > 3 Then
                        temp = parts(1) & ", " & parts(2) & ", " & parts(3)
                        pOU = temp.Replace("OU=", "")
                    End If
                End If
            Catch ldap_ex As System.Runtime.InteropServices.COMException
                ' ignore
            End Try
        End If

        ' IE Version (more straight forward)
        key = reg_hkcr.OpenSubKey("CLSID\{25336920-03F9-11CF-8FD0-00AA00686F13}\DefaultIcon", False)
        If Not IsNothing(key) Then
            Dim temp, IE_Path As String
            Dim cnt As Integer

            temp = key.GetValue("", "").ToString.Split(","c)(0)
            IE_Path = ConvUNC(RemotePC, temp)
            If File.Exists(IE_Path) Then
                temp = GetVersion(IE_Path)
                ' shorten it up a wee bit
                cnt = InStr(temp, " ")
                If cnt > 0 Then
                    pIE = Left(temp, cnt - 1)
                Else
                    pIE = temp
                End If
            End If
            key.Close()
        End If

        ' Get the date of the last virus scan (could be in 1 of 3 locations)
        key = reg_hklm.OpenSubKey("SOFTWARE\Intel\LANDesk\VirusProtect6\CurrentVersion", False)
        If IsNothing(key) Then
            key = reg_hklm.OpenSubKey("SOFTWARE\Wow6432Node\Symantec\Symantec Endpoint Protection\AV", False)
        End If
        If IsNothing(key) Then
            key = reg_hklm.OpenSubKey("SOFTWARE\Symantec\Symantec Endpoint Protection\AV", False)
        End If
        If Not IsNothing(key) Then
            Dim temp As String
            Dim buf() As Byte
            Dim ver As UInt32

            buf = CType(key.GetValue("TimeOfLastScan"), Byte())
            If buf.Length > 5 Then
                temp = buf(1) + 1 & "/" & buf(2) & "/" & buf(0) + 1970 & " " & Format(buf(3), "00") & ":" & Format(buf(4), "00") & ":" & Format(buf(5), "00")
                If IsDate(temp) Then
                    pVirus_Scan = Date.Parse(temp)
                End If
            End If

            buf = CType(key.GetValue("PatternFileDate"), Byte())
            If buf.Length > 5 Then
                temp = buf(1) + 1 & "/" & buf(2) & "/" & buf(0) + 1970 & " " & Format(buf(3), "00") & ":" & Format(buf(4), "00") & ":" & Format(buf(5), "00")
                If IsDate(temp) Then
                    pVirus_Defs = Date.Parse(temp)
                End If
            End If

            If key.Name.Contains("Symantec Endpoint Protection") Then
                ' Note: does not use the Wow6432Node even on a 64-bit OS
                Dim key2 As RegistryKey = reg_hklm.OpenSubKey("SOFTWARE\Symantec\Symantec Endpoint Protection\SMC", False)
                If Not IsNothing(key2) Then
                    pVirus_Ver = key2.GetValue("ProductVersion", "").ToString
                    key2.Close()
                End If
            Else
                ver = CType(key.GetValue("ProductVersion", 0), UInt32)
                temp = (ver And &HFFF).ToString & "0000"
                pVirus_Ver = temp.Substring(0, 2) & "." & temp.Substring(2, 1) & "." & temp.Substring(3, 1) & "." & (ver >> 16)
            End If
            key.Close()
        End If

        key = reg_hklm.OpenSubKey("SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update\Results\Install", False)
        If Not IsNothing(key) Then
            Dim temp As String

            temp = CType(key.GetValue("LastSuccessTime"), String)
            pLastQFE = Date.Parse(temp)
        End If

    End Sub

    '
    ' Convert a Remote PC name, Local path name pair into a UNC style path
    '
    Private Function ConvUNC(ByVal RemotePC As String, ByVal Path As String) As String
        Dim ans As String

        If RemotePC = "" Or String.Compare(RemotePC, Environment.MachineName, True) = 0 Then
            Return Path
        End If

        ans = ""
        If Path.Length > 2 Then
            ans = "\\" & RemotePC & "\" & Path.Substring(0, 1) & "$" & Path.Substring(2)
        End If
        Return ans
    End Function

    '
    ' Format the IP address in a manner that supports sorting
    '
    Private Function Format_IP(ByVal ip As String) As String
        Dim temp() As String
        Dim ans As New System.Text.StringBuilder
        Dim i As Integer

        If Not IsNothing(ip) AndAlso ip <> "" Then
            ' start with the unformated string
            ans.Append(ip)

            ' for IPv4
            temp = Split(ip, ".")
            If UBound(temp) = 3 Then
                ans.Length = 0
                For i = 0 To 3
                    ans.AppendFormat("{0:000}", CInt(temp(i)))
                    If i <> 3 Then
                        ans.Append(".")
                    End If
                Next
            End If

            ' try this again for IPv6
            ' WMI uses the "zero compressed" notation, which we expand
            temp = Split(ip, ":")
            If UBound(temp) = 5 Then
                ans.Length = 0
                For i = 0 To 5
                    ans.Append(temp(i).PadLeft(4, "0"c))
                    If i <> 5 Then
                        ans.Append(":")
                    End If
                Next
            End If
        End If

        Return ans.ToString
    End Function

    '
    ' Get the file version information.
    '
    Public Shared Function GetVersion(ByVal file As String) As String
        Dim fvi As FileVersionInfo
        Dim ans As String

        ans = ""
        If System.IO.File.Exists(file) Then
            fvi = FileVersionInfo.GetVersionInfo(file)
            If fvi.FileVersion <> "" Then
                ans = fvi.FileVersion.Replace(",", ".")
            Else
                ans = fvi.FileMajorPart & "." & fvi.FileMinorPart & "." & fvi.FileBuildPart & "." & fvi.FilePrivatePart
            End If
        End If

        Return ans
    End Function

    '
    ' Home-made version of the CPU detection routine (used in GetCPU)
    '
    Private Function GetCPUType(ByVal vendor As String, ByVal s As String) As String
        Dim extfamily, family, model As Integer
        Dim ans As String

        extfamily = CInt("&h" & s.Substring(11, 1))
        family = CInt("&h" & s.Substring(13, 1))
        model = CInt("&h" & s.Substring(14, 1))

        ans = ""
        Select Case vendor
            Case "GenuineIntel"
                Select Case family
                    Case 4
                        ans = "80486"
                    Case 5
                        If model < 4 Then
                            ans = "Pentium"
                        Else
                            ans = "Pentium MMX"
                        End If
                    Case 6
                        Select Case model
                            Case 1
                                ans = "Pentium Pro"
                            Case 3, 5
                                ans = "Pentium II"   ' or Celeron
                            Case 6
                                ans = "Celeron"
                            Case 7
                                If extfamily = 1 Then
                                    ans = "Core 2"
                                Else
                                    ans = "Pentium III"
                                End If
                            Case 8
                                ans = "Pentium III"
                            Case 9, 13
                                ans = "Pentium M"
                            Case 10
                                ans = "Pentium III Xeon"
                            Case 11
                                ans = "Pentium III M"
                            Case 14
                                ans = "Core"
                            Case 15
                                ans = "Core 2"
                            Case Else
                                ans = "Intel Family 6, model " & model
                        End Select
                    Case 15
                        ans = "Pentium 4"
                    Case Else
                        ans = "Intel Family " & family & ", model " & model
                End Select
            Case "AuthenticAMD"
                Select Case family
                    Case 4
                        ans = "Am486"
                    Case 5
                        Select Case model
                            Case 0 To 3
                                ans = "K5"
                            Case 6, 7
                                ans = "K6"
                            Case 8
                                ans = "K6-2"
                            Case 9
                                ans = "K6-III"
                            Case Else
                                ans = "AMD Family 5, model " & model
                        End Select
                    Case 6
                        Select Case model
                            Case 1, 2, 4, 6
                                ans = "Athlon"
                            Case 3, 7
                                ans = "Duron"
                            Case 8, 10
                                ans = "Athlon XP"
                            Case Else
                                ans = "AMD Family 6, model " & model
                        End Select
                    Case 15
                        Select Case model
                            Case 2
                                ans = "Phenom"
                            Case 3, 11
                                ans = "Althon 64 x2"
                            Case 4
                                ans = "Althon 64"
                            Case 5
                                ans = "Operton"
                            Case 7
                                ans = "Althon 64 FX"
                            Case Else
                                ans = "AMD Family 15, model " & model
                        End Select
                    Case Else
                        ans = "AMD Family " & family & ", model " & model
                End Select
            Case "CyrixInstead"
                Select Case family
                    Case 4
                        ans = "MediaGX"
                    Case 5
                        ans = "6x86"
                    Case 6
                        ans = "6x86MX/MII"
                    Case Else
                        ans = "Cyrix Family " & family & ", model " & model
                End Select
            Case "CentaurHauls"  ' IDT
                Select Case model
                    Case 4
                        ans = "WinChip"
                    Case 8
                        ans = "WinChip 2"
                    Case 9
                        ans = "WinChip 3"
                    Case 10
                        ans = "Via C7"
                    Case Else
                        ans = "IDT Family " & family & ", model " & model
                End Select
            Case "RiseRiseRise"  ' Rise (never heard of 'em)
                If model < 3 Then
                    ans = "mP6"
                Else
                    ans = "mP6-II"
                End If
            Case "GenuineTMx86"
                Select Case family
                    Case 5
                        ans = "Transmeta TM5x00"
                    Case 15
                        ans = "Transmeta TM8x00"
                    Case Else
                        ans = "Transmeta Family " & family & ", model " & model
                End Select
            Case Else
                ans = vendor & " " & family & ", model " & model
        End Select

        Return ans
    End Function

    '
    ' A simple method of rounding off the CPU as returned by WMI.
    '
    Private Function RoundCPUSpeed(ByVal raw As Integer, ByVal divisor As Integer) As Integer
        Dim temp, div As Double
        Dim ans As Integer

        If raw = 0 Then
            Return 0
        End If

        ' Use the "external speed" to determine the divisor for the
        ' CPU multiplier
        Select Case divisor
            Case 100
                div = 100.0
            Case 133
                div = 133.3333
            Case 166
                div = 166.6666
            Case 200
                div = 200.0
            Case 400    ' quad-pumped
                div = 100.0
            Case 532, 533
                div = 133.3333
            Case 800
                div = 200.0
            Case Else
                div = 33.3333
        End Select

        temp = Math.Round(raw / div)
        ans = CInt(Math.Round(temp * div))

        Return ans
    End Function

    '
    ' Are you an administrator on this PC?
    '
    Public Function IsAdmin() As Boolean
        Dim MyPrincipal As WindowsPrincipal

        AppDomain.CurrentDomain.SetPrincipalPolicy(PrincipalPolicy.WindowsPrincipal)
        MyPrincipal = CType(Thread.CurrentPrincipal, WindowsPrincipal)
        Try
            If MyPrincipal.IsInRole(WindowsBuiltInRole.Administrator) Then
                Return True
            Else
                Return False
            End If
        Catch
        End Try

        ' if the built-in role doesn't exist... then report false
        Return False
    End Function


End Class
