﻿Imports System.IO
Imports System.Text

Module Main

    Sub Main()
        Dim wm As New Watermark

        Try
            wm.MakeWallPaper(WallPaperText())
        Catch ex As Exception
            Dim fs As FileStream = New FileStream(My.Settings.ErrorLog, FileMode.Append)
            Dim sw As StreamWriter = New StreamWriter(fs)
            Dim sb As New StringBuilder

            Do While Not IsNothing(ex)
                sb.Append("PCName: " & Environment.MachineName & vbCrLf)
                sb.Append("UserName: " & Environment.UserName.ToLower & vbCrLf)
                sb.Append("Date: " & Now() & vbCrLf)
                sb.Append("Exception: " & ex.GetType.ToString & vbCrLf)
                sb.Append("Error: " & ex.Message.TrimEnd(vbCrLf.ToCharArray) & vbCrLf)
                sb.Append("Location: " & ex.StackTrace & vbCrLf)
                ' repeat for all nested inner exceptions
                ex = ex.InnerException
            Loop

            sw.WriteLine(sb.ToString)
            sw.WriteLine("")
            sw.Close()
            fs.Close()
        End Try

    End Sub

    '
    ' Make a text summary for the wallpaper
    ' Note: The contents of this summary are only configurable via editing the
    ' source code and recompiling.
    '
    Private Function WallPaperText() As String
        Dim buf As New System.Text.StringBuilder
        Dim wmi As New Info

        wmi.Doit("")

        buf.Append("Name: " & wmi.Name & vbCrLf)
        buf.Append("OU: " & wmi.OU & vbCrLf)
        buf.Append("Model: " & wmi.Model & vbCrLf)
        buf.Append("Serial: " & wmi.Serial & vbCrLf)
        buf.Append("BIOS_Ver: " & wmi.BIOS & vbCrLf)
        buf.Append("User: " & Environment.UserName & vbCrLf)
        buf.Append("IsAdmin: " & wmi.IsAdmin.ToString & vbCrLf)
        buf.Append("Comment: " & wmi.Comment & vbCrLf)
        buf.Append("Date: " & Now.ToString & vbCrLf)
        buf.Append("IP_Address: " & wmi.IP & vbCrLf)
        buf.Append("DHCP: " & wmi.DHCP & vbCrLf)
        buf.Append("OS: " & wmi.OS & vbCrLf)
        buf.Append("CPU_Type: " & wmi.CPU & vbCrLf)
        buf.Append("CPU_Speed: " & wmi.CPU_Speed & vbCrLf)
        buf.Append("Memory: " & wmi.Memory & vbCrLf)
        buf.Append("Disk_Size: " & wmi.Disk_Size & vbCrLf)
        buf.Append("Disk_Free: " & wmi.Disk_Free & vbCrLf)
        buf.Append("Install_Rev: " & wmi.InstallRev & vbCrLf)
        buf.Append("Install_Date: " & wmi.InstallDate & vbCrLf)
        buf.Append("MSOffice: " & wmi.Office & vbCrLf)
        buf.Append("IE_Version: " & wmi.IE & vbCrLf)
        buf.Append("Virus_Version: " & wmi.Virus_Ver & vbCrLf)
        buf.Append("Virus_Defs: " & wmi.Virus_Defs & vbCrLf)
        buf.Append("Virus_Scan: " & wmi.Virus_Scan & vbCrLf)
        buf.Append("LastQFE: " & wmi.LastQFE & vbCrLf)
        buf.Append("LastBoot: " & wmi.LastBoot & vbCrLf)

        Return buf.ToString
    End Function
End Module
